# Module `proton.utils`

## Module Summary

`BlockingConnection` | A synchronous style connection wrapper.
`BlockingSender` | A synchronous sender wrapper.
`BlockingReceiver` | A synchronous receiver wrapper.
`SyncRequestResponse` | Implementation of the synchronous request-response (aka RPC) pattern.

### Exceptions

`SendException` | Exception used to indicate an exceptional state/condition on a send request.
`LinkDetached` | The exception raised when the remote peer unexpectedly closes a link in a blocking context, or an unexpected link error occurs.
`ConnectionClosed` | The exception raised when the remote peer unexpectedly closes a connection in a blocking context, or an unexpected connection error occurs.

## Module Detail